package ru.dbotthepony.mc.prng.mixin;

import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Overwrite;

@Mixin(Level.class)
public abstract class LevelMixin {
	@Overwrite
	public BlockPos getBlockRandomPos(int x, int y, int z, int yMask) {
		long value = ((Level) (Object) this).random.nextLong();
		int selectX = (int) (value & 15);
		int selectZ = (int) ((value >>> 8) & 15);
		int selectY = (int) ((value >>> 16) & yMask);
		return new BlockPos(selectX + x, selectY + y, selectZ + z);
	}
}
